diff -rNci gcc-2.7.2/toplev.c gcc-2.7.2p/toplev.c
*** gcc-2.7.2/toplev.c	Fri Oct 20 21:56:35 1995
--- gcc-2.7.2p/toplev.c	Tue Jan 23 09:25:32 1996
***************
*** 205,211 ****
--- 201,209 ----
  int combine_dump = 0;
  int sched_dump = 0;
  int local_reg_dump = 0;
+ int memory_simplify_dump = 0; /* intel2 */
  int global_reg_dump = 0;
+ int loop2_dump = 0; /* intel1 */
  int sched2_dump = 0;
  int jump2_opt_dump = 0;
  int dbr_sched_dump = 0;
***************
*** 374,379 ****
--- 372,413 ----
  /* Nonzero enables strength-reduction in loop.c.  */
  
  int flag_strength_reduce = 0;
+ /* intel1 my optimization controllers */
+ int flag_opt_reg_use = 0;
+ int flag_all_mem_givs = 0;
+ int flag_reduce_index_givs = 0;
+ int flag_peep_spills = 0;
+ int flag_loop_after_global = 0;
+ int flag_jump_back = 0;
+ int flag_copy_prop = 0;
+ int flag_lift_stores = 0;
+ int flag_runtime_lift_stores = 0;
+ int flag_compare_elim = 0;
+ int flag_sign_extension_elim = 0;
+ int flag_sftwr_pipe = 0;
+ int flag_opt_jumps_out = 0;
+ int flag_replace_mem = 0;
+ int flag_replace_stack_mem = 0;
+ int flag_reg_reg_copy_opt = 0;
+ int flag_do_offload = 0;
+ int flag_opt_reg_stack = 0;
+ int flag_correct_cse_mistakes = 0;
+ int flag_push_load_into_loop = 0;
+ int flag_risc = 0;
+ int flag_risc_const = 0;
+ int flag_risc_mem_dest = 0;	/* intel2 */
+ int flag_replace_reload_regs = 0;
+ int flag_recombine = 0;
+ int flag_swap_for_agi = 0;
+ int flag_no_omit_frame_pointer = 0;
+ int flag_no_risc = 0;
+ int flag_no_risc_const = 0;
+ int flag_no_risc_mem_dest = 0;	/* intel2 */
+ int flag_no_recombine = 0;
+ int flag_schedule_stack_reg_insns = 0;
+ int flag_interleave_stack_non_stack = 0;
+ int flag_no_schedule_stack_reg_insns = 0;
+ int flag_no_interleave_stack_non_stack = 0;
  
  /* Nonzero enables loop unrolling in unroll.c.  Only loops for which the
     number of iterations can be calculated at compile-time (UNROLL_COMPLETELY,
***************
*** 567,573 ****
    {"verbose-asm", &flag_verbose_asm, 1},
    {"gnu-linker", &flag_gnu_linker, 1},
    {"pack-struct", &flag_pack_struct, 1},
!   {"bytecode", &output_bytecode, 1}
  };
  
  /* Table of language-specific options.  */
--- 601,642 ----
    {"verbose-asm", &flag_verbose_asm, 1},
    {"gnu-linker", &flag_gnu_linker, 1},
    {"pack-struct", &flag_pack_struct, 1},
!   {"bytecode", &output_bytecode, 1},
!   /* intel1 */
!   {"compare-elim", &flag_compare_elim, 1},
!   {"sign-extension-elim", &flag_sign_extension_elim, 1},
!   {"jump-back", &flag_jump_back, 1},
!   {"loop-after-global", &flag_loop_after_global, 1},
!   {"opt-reg-use", &flag_opt_reg_use, 1},
!   {"all-mem-givs", &flag_all_mem_givs, 1},
!   {"reduce-index-givs", &flag_reduce_index_givs, 1},
!   {"peep-spills", &flag_peep_spills, 1},
!   {"copy-prop", &flag_copy_prop, 1},
!   {"lift-stores", &flag_lift_stores, 1},
!   {"runtime-lift-stores", &flag_runtime_lift_stores, 1},
!   {"do-offload", &flag_do_offload, 1},
!   {"opt-reg-stack", &flag_opt_reg_stack, 1},
!   {"correct-cse-mistakes", &flag_correct_cse_mistakes, 1},
!   {"spl", &flag_sftwr_pipe, 1},
!   {"opt-jumps-out", &flag_opt_jumps_out, 1},
!   {"replace-mem", &flag_replace_mem, 1},
!   {"replace-stack-mem", &flag_replace_stack_mem, 1},
!   {"no-interleave-stack-non-stack", &flag_no_interleave_stack_non_stack, 1},
!   {"interleave-stack-non-stack", &flag_interleave_stack_non_stack, 1},
!   {"no-schedule-stack-reg-insns", &flag_no_schedule_stack_reg_insns, 1},
!   {"schedule-stack-reg-insns", &flag_schedule_stack_reg_insns, 1},
!   {"reg-reg-copy-opt", &flag_reg_reg_copy_opt, 1},
!   {"push-load-into-loop", &flag_push_load_into_loop, 1},
!   {"swap-for-agi", &flag_swap_for_agi, 1},
!   {"no-recombine", &flag_no_recombine, 1},
!   {"recombine", &flag_recombine, 1},
!   {"no-risc", &flag_no_risc, 1},
!   {"risc", &flag_risc, 1},
!   {"no-risc-const", &flag_no_risc_const, 1},
!   {"risc-const", &flag_risc_const, 1},
!   {"replace-reload-regs", &flag_replace_reload_regs, 1},
!   {"no-risc-mem-dest", &flag_no_risc_mem_dest, 1},	/* intel2 */
!   {"risc-mem-dest", &flag_risc_mem_dest, 1},	/* intel2 */
  };
  
  /* Table of language-specific options.  */
***************
*** 756,761 ****
--- 825,833 ----
  FILE *sched_dump_file;
  FILE *local_reg_dump_file;
  FILE *global_reg_dump_file;
+ FILE *memory_simplify_dump_file; /* intel2 */
+ /* intel1 */
+ FILE *loop2_dump_file;
  FILE *sched2_dump_file;
  FILE *jump2_opt_dump_file;
  FILE *dbr_sched_dump_file;
***************
*** 775,780 ****
--- 847,855 ----
  int sched_time;
  int local_alloc_time;
  int global_alloc_time;
+ int memory_simplify_time; /* intel2 */
+ /* intel1 */
+ int loop2_time;
  int sched2_time;
  int dbr_sched_time;
  int shorten_branch_time;
***************
*** 926,931 ****
--- 1001,1010 ----
      fflush (local_reg_dump_file);
    if (global_reg_dump_file)
      fflush (global_reg_dump_file);
+   if (memory_simplify_dump_file) /* intel2 */
+       fflush (memory_simplify_dump_file);
+   if (loop2_dump_file) /* intel1 */
+     fflush (loop2_dump_file);
    if (sched2_dump_file)
      fflush (sched2_dump_file);
    if (jump2_opt_dump_file)
***************
*** 1052,1059 ****
    (*print_error_function) (file);
  
    if (input_file_stack && input_file_stack->next != 0
!       && input_file_stack_tick != last_error_tick
!       && file == input_filename)
      {
        fprintf (stderr, "In file included");
        for (p = input_file_stack->next; p; p = p->next)
--- 1131,1137 ----
    (*print_error_function) (file);
  
    if (input_file_stack && input_file_stack->next != 0
!       && input_file_stack_tick != last_error_tick)
      {
        fprintf (stderr, "In file included");
        for (p = input_file_stack->next; p; p = p->next)
***************
*** 1085,1092 ****
      HOST_WIDE_INT v1 = va_arg(ap, HOST_WIDE_INT);
      HOST_WIDE_INT v2 = va_arg(ap, HOST_WIDE_INT);
      HOST_WIDE_INT v3 = va_arg(ap, HOST_WIDE_INT);
!     HOST_WIDE_INT v4 = va_arg(ap, HOST_WIDE_INT);
!     fprintf (stderr, s, v1, v2, v3, v4);
    }
  #endif
  }
--- 1163,1169 ----
      HOST_WIDE_INT v1 = va_arg(ap, HOST_WIDE_INT);
      HOST_WIDE_INT v2 = va_arg(ap, HOST_WIDE_INT);
      HOST_WIDE_INT v3 = va_arg(ap, HOST_WIDE_INT);
!     fprintf (stderr, s, v1, v2, v3);
    }
  #endif
  }
***************
*** 1863,1883 ****
  }
  
  /* Strip off a legitimate source ending from the input string NAME of
!    length LEN.  Rather than having to know the names used by all of
!    our front ends, we strip off an ending of a period followed by one,
!    two, or three characters.  */
  
  void
  strip_off_ending (name, len)
       char *name;
       int len;
  {
!   if (len > 2 && name[len - 2] == '.')
!     name[len - 2] = '\0';
!   else if (len > 3 && name[len - 3] == '.')
!     name[len - 3] = '\0';
!   else if (len > 4 && name[len - 4] == '.')
!     name[len - 4] = '\0';
  }
  
  /* Output a quoted string.  */
--- 1940,1978 ----
  }
  
  /* Strip off a legitimate source ending from the input string NAME of
!    length LEN. */
  
  void
  strip_off_ending (name, len)
       char *name;
       int len;
  {
!   if (len > 2 && ! strcmp (".c", name + len - 2))
!     name[len - 2] = 0;
!   else if (len > 2 && ! strcmp (".m", name + len - 2))
!     name[len - 2] = 0;
!   else if (len > 2 && ! strcmp (".i", name + len - 2))
!     name[len - 2] = 0;
!   else if (len > 3 && ! strcmp (".ii", name + len - 3))
!     name[len - 3] = 0;
!   else if (len > 3 && ! strcmp (".co", name + len - 3))
!     name[len - 3] = 0;
!   else if (len > 3 && ! strcmp (".cc", name + len - 3))
!     name[len - 3] = 0;
!   else if (len > 2 && ! strcmp (".C", name + len - 2))
!     name[len - 2] = 0;
!   else if (len > 4 && ! strcmp (".cxx", name + len - 4))
!     name[len - 4] = 0;
!   else if (len > 4 && ! strcmp (".cpp", name + len - 4))
!     name[len - 4] = 0;
!   else if (len > 2 && ! strcmp (".f", name + len - 2))
!     name[len - 2] = 0;
!   /* Ada will use extensions like .ada, .adb, and .ads, so just test
!      for "ad".  */
!   else if (len > 4 && ! strncmp (".ad", name + len - 4, 3))
!     name[len - 4] = 0;
!   else if (len > 4 && ! strcmp (".atr", name + len - 4))
!     name[len - 4] = 0;
  }
  
  /* Output a quoted string.  */
***************
*** 1984,1989 ****
--- 2079,2087 ----
    sched_time = 0;
    local_alloc_time = 0;
    global_alloc_time = 0;
+   memory_simplify_time = 0; /* intel2 */
+   /* intel1 */
+   loop2_time = 0;
    sched2_time = 0;
    dbr_sched_time = 0;
    shorten_branch_time = 0;
***************
*** 2080,2085 ****
--- 2178,2194 ----
    if (global_reg_dump)
      global_reg_dump_file = open_dump_file (dump_base_name, ".greg");
  
+   /* intel1 */
+   /* If loop invariants after greg dump desired, open the output file.  */
+   if (loop2_dump)
+   	loop2_dump_file = open_dump_file(dump_base_name, ".l2" );
+ 
+ /* intel2 - begin */
+   /* If memory_simplify dump desired, open the output file.  */
+   if (memory_simplify_dump)
+   	memory_simplify_dump_file=open_dump_file(dump_base_name, ".msim");
+ /* intel2 - end */
+ 
    /* If 2nd scheduling dump desired, open the output file.  */
    if (sched2_dump)
      sched2_dump_file = open_dump_file (dump_base_name, ".sched2");
***************
*** 2492,2497 ****
--- 2601,2612 ----
    if (global_reg_dump)
      fclose (global_reg_dump_file);
  
+   if (memory_simplify_dump)
+     fclose (memory_simplify_dump_file); /* intel2 */
+ 	
+   if (loop2_dump) /* intel1 */
+     fclose (loop2_dump_file);
+ 
    if (sched2_dump)
      fclose (sched2_dump_file);
  
***************
*** 2520,2547 ****
      {
        fprintf (stderr,"\n");
        print_time ("parse", parse_time);
- 
        if (!output_bytecode)
! 	{
! 	  print_time ("integration", integration_time);
! 	  print_time ("jump", jump_time);
! 	  print_time ("cse", cse_time);
! 	  print_time ("loop", loop_time);
! 	  print_time ("cse2", cse2_time);
! 	  print_time ("flow", flow_time);
! 	  print_time ("combine", combine_time);
! 	  print_time ("sched", sched_time);
! 	  print_time ("local-alloc", local_alloc_time);
! 	  print_time ("global-alloc", global_alloc_time);
! 	  print_time ("sched2", sched2_time);
! 	  print_time ("dbranch", dbr_sched_time);
! 	  print_time ("shorten-branch", shorten_branch_time);
! 	  print_time ("stack-reg", stack_reg_time);
! 	  print_time ("final", final_time);
! 	  print_time ("varconst", varconst_time);
! 	  print_time ("symout", symout_time);
! 	  print_time ("dump", dump_time);
! 	}
      }
  }
  
--- 2635,2664 ----
      {
        fprintf (stderr,"\n");
        print_time ("parse", parse_time);
        if (!output_bytecode)
! 	  {
!         print_time ("integration", integration_time);
!         print_time ("jump", jump_time);
!         print_time ("cse", cse_time);
!         print_time ("loop", loop_time);
!         print_time ("cse2", cse2_time);
!         print_time ("flow", flow_time);
!         print_time ("combine", combine_time);
!         print_time ("sched", sched_time);
!         print_time ("local-alloc", local_alloc_time);
!         print_time ("global-alloc", global_alloc_time);
!         print_time ("memory-simplify", memory_simplify_time); /* intel2 */
!         /* intel1 */
!         print_time ("loop2", loop2_time);
!         print_time ("sched2", sched2_time);
!         print_time ("dbranch", dbr_sched_time);
!         print_time ("shorten-branch", shorten_branch_time);
!         print_time ("stack-reg", stack_reg_time);
!         print_time ("final", final_time);
!         print_time ("varconst", varconst_time);
!         print_time ("symout", symout_time);
!         print_time ("dump", dump_time);
!       }
      }
  }
  
***************
*** 2981,2987 ****
  	 and write some of the results to dump file.  */
  
        TIMEVAR (flow_time, flow_analysis (insns, max_reg_num (),
! 					 flow_dump_file));
        if (warn_uninitialized)
  	{
  	  uninitialized_vars_warning (DECL_INITIAL (decl));
--- 3098,3104 ----
  	 and write some of the results to dump file.  */
  
        TIMEVAR (flow_time, flow_analysis (insns, max_reg_num (),
! 					 flow_dump_file /* intel2: */, 1));
        if (warn_uninitialized)
  	{
  	  uninitialized_vars_warning (DECL_INITIAL (decl));
***************
*** 3015,3020 ****
--- 3132,3162 ----
  	       fflush (combine_dump_file);
  	     });
  
+   /* intel1 */
+ #ifdef STACK_REGS
+ #ifdef IS_STACK_MODE
+   if (optimize > 0 && flag_opt_reg_stack)
+     {
+       if(stack_reg_dump)
+         {
+           TIMEVAR (dump_time,
+ 	           {
+ 		     fprintf (stack_reg_dump_file, "\n;; Function %s\n\n",
+ 			      IDENTIFIER_POINTER (DECL_NAME (decl)));
+ 	           });
+         }
+       opt_reg_stack();
+       if(stack_reg_dump)
+         {
+           TIMEVAR (dump_time,
+ 	           {
+ 		     print_rtl (stack_reg_dump_file, insns);
+ 		     fflush (stack_reg_dump_file);
+ 	           });
+         }
+     }
+ #endif
+ #endif
    /* Print function header into sched dump now
       because doing the sched analysis makes some of the dump.  */
  
***************
*** 3082,3087 ****
--- 3224,3235 ----
  	       failure = reload (insns, 0, global_reg_dump_file);
  	   });
  
+  /* intel1 */
+   if(optimize > 0 && flag_reg_reg_copy_opt)
+     {
+ 	  reg_to_reg_copy_opt(insns, global_reg_dump_file);
+     }  
+ 
    if (global_reg_dump)
      TIMEVAR (dump_time,
  	     {
***************
*** 3095,3100 ****
--- 3243,3312 ----
  
    reload_completed = 1;
  
+ #ifdef STACK_REGS
+   /* intel1 */
+   if (optimize > 0 && flag_opt_reg_stack)
+     {
+       TIMEVAR (stack_reg_time, float_to_int_cmp (insns, 0));
+     }
+ #endif
+ 
+   /* intel1 */
+   if (loop2_dump)
+     TIMEVAR (dump_time,
+ 	     {
+ 	       fprintf (loop2_dump_file, "\n;; Function %s\n\n",
+ 			IDENTIFIER_POINTER (DECL_NAME (decl)));
+ 	     });
+ 
+   if(optimize>0 && flag_loop_after_global) 
+   {
+       TIMEVAR (loop2_time,
+ 	       {
+ 	         /* intel2 - begin */
+ 	         if (flag_replace_reload_regs)
+ 	           replace_reload_registers (get_insns(),
+ 				             loop2_dump ? loop2_dump_file : 0);
+ 	         /* intel2 - end */
+                  loop_after_global(get_insns(),loop2_dump ? loop2_dump_file : 0); 
+ 	       });
+   }
+   if (optimize>0 && flag_peep_spills)
+     {
+      TIMEVAR (loop2_time,
+ 	      {
+ 	      peep_spills(get_insns(),loop2_dump ? loop2_dump_file : 0); 
+ 	      });
+     }
+     
+   /* Dump rtl code after loop2 opt, if we are doing that.  */
+ 
+   if (loop2_dump && flag_loop_after_global)
+     TIMEVAR (dump_time,
+ 	     {
+ 	       print_rtl (loop2_dump_file, insns);
+ 	       fflush (loop2_dump_file);
+ 	     });
+ 
+ /* intel2 - begin */
+   if (optimize>0 && flag_risc)
+     {
+       if (memory_simplify_dump)
+         TIMEVAR (dump_time,
+ 	         fprintf (memory_simplify_dump_file, "\n;; Function %s\n\n",
+ 		          IDENTIFIER_POINTER (DECL_NAME (decl))));
+     
+   	    TIMEVAR (memory_simplify_time,
+ 	       memory_simplify (memory_simplify_dump ? memory_simplify_dump_file : 0,
+ 							    insns));
+       if (memory_simplify_dump)
+         TIMEVAR (dump_time,
+ 	         {
+ 	           print_rtl (memory_simplify_dump_file, insns);
+ 	           fflush (memory_simplify_dump_file);
+ 	         });
+     }
+ /* intel2 - end */
    /* On some machines, the prologue and epilogue code, or parts thereof,
       can be represented as RTL.  Doing so lets us schedule insns between
       it and the rest of the code and also allows delayed branch
***************
*** 3126,3131 ****
--- 3338,3350 ----
  		 });
      }
  
+   /* intel2 - begin */
+   /* Combine those riscified insns that were not used for scheduling */
+   if (flag_risc && flag_recombine)
+     combine_unscheded (get_insns (),max_reg_num ());
+   /* intel2 - end */
+ 
+ 
  #ifdef LEAF_REGISTERS
    leaf_function = 0;
    if (optimize > 0 && only_leaf_regs_used () && leaf_function_p ())
***************
*** 3185,3190 ****
--- 3404,3414 ----
  	   });
  
  #ifdef STACK_REGS
+   /* intel1 */
+   if (optimize > 0 && flag_opt_reg_stack)
+     {
+       TIMEVAR (stack_reg_time, float_to_int_cmp (insns));
+     }
    TIMEVAR (stack_reg_time, reg_to_stack (insns, stack_reg_dump_file));
    if (stack_reg_dump)
      {
***************
*** 3196,3201 ****
--- 3420,3432 ----
  		 fflush (stack_reg_dump_file);
  	       });
      }
+ /* intel1 spl */
+ #ifdef STORE_NOT_SET_CC0
+   if(flag_sftwr_pipe)
+     {
+       do_spl(insns);
+     }
+ #endif
  #endif
  
    /* Now turn the rtl into assembler code.  */
***************
*** 3267,3275 ****
  
    reload_completed = 0;
  
-   /* Clear out the insn_length contents now that they are no longer valid.  */
-   init_insn_lengths ();
- 
    /* Clear out the real_constant_chain before some of the rtx's
       it runs through become garbage.  */
  
--- 3498,3503 ----
***************
*** 3451,3460 ****
--- 3679,3690 ----
   		    dbr_sched_dump = 1;
   		    flow_dump = 1;
   		    global_reg_dump = 1;
+ 		    memory_simplify_dump = 1; /* intel2 */
   		    jump_opt_dump = 1;
   		    jump2_opt_dump = 1;
   		    local_reg_dump = 1;
   		    loop_dump = 1;
+  		    loop2_dump = 1; /* intel1 */
   		    rtl_dump = 1;
   		    cse_dump = 1, cse2_dump = 1;
   		    sched_dump = 1;
***************
*** 3476,3481 ****
--- 3706,3716 ----
  		  case 'g':
  		    global_reg_dump = 1;
  		    break;
+ 		  /* intel2 - begin */
+ 		  case 'b':
+ 		    memory_simplify_dump = 1;
+ 		    break;
+ 		  /* intel2 - end */
  		  case 'j':
  		    jump_opt_dump = 1;
  		    break;
***************
*** 3488,3493 ****
--- 3723,3732 ----
  		  case 'L':
  		    loop_dump = 1;
  		    break;
+ 		    /* intel1 */
+ 		  case 'A':
+ 		    loop2_dump = 1;
+ 		    break;
  		  case 'm':
  		    flag_print_mem = 1;
  		    break;
***************
*** 3791,3798 ****
  		use_gnu_debug_info_extensions = DEFAULT_GDB_EXTENSIONS;
  #endif	      
  	      if (write_symbols == NO_DEBUG)
! 		warning ("`-%s' not supported by this configuration of GCC",
! 			 str);
  	      else if (level == 0)
  		write_symbols = NO_DEBUG;
  	      else
--- 4030,4036 ----
  		use_gnu_debug_info_extensions = DEFAULT_GDB_EXTENSIONS;
  #endif	      
  	      if (write_symbols == NO_DEBUG)
! 		warning ("`-%s' option not supported on this version of GCC", str);
  	      else if (level == 0)
  		write_symbols = NO_DEBUG;
  	      else
***************
*** 3827,3833 ****
      {
  #ifndef TARGET_SUPPORTS_BYTECODE
        /* Just die with a fatal error if not supported */
!       fatal ("-fbytecode not supporter for this target");
  #else
        bc_initialize ();
  #endif
--- 4065,4071 ----
      {
  #ifndef TARGET_SUPPORTS_BYTECODE
        /* Just die with a fatal error if not supported */
!       fatal ("-fbytecode not supported for this target");
  #else
        bc_initialize ();
  #endif
***************
*** 3851,3857 ****
    if (write_symbols == DWARF_DEBUG
        && strcmp (language_string, "GNU C++") == 0)
      {
!       warning ("-g option not supported for C++ on systems using the DWARF debugging format");
        write_symbols = NO_DEBUG;
      }
  #endif /* defined(DWARF_DEBUGGING_INFO) */
--- 4089,4095 ----
    if (write_symbols == DWARF_DEBUG
        && strcmp (language_string, "GNU C++") == 0)
      {
!       warning ("-g option not supported for C++ on SVR4 systems");
        write_symbols = NO_DEBUG;
      }
  #endif /* defined(DWARF_DEBUGGING_INFO) */
***************
*** 3893,3898 ****
--- 4131,4139 ----
  #ifdef TARGET_VERSION
        TARGET_VERSION;
  #endif
+ #ifdef SUB_TARGET_VERSION
+       SUB_TARGET_VERSION;
+ #endif
  #ifdef __GNUC__
  #ifndef __VERSION__
  #define __VERSION__ "[unknown]"
***************
*** 3910,3915 ****
--- 4151,4159 ----
  #if !defined(OS2) && !defined(VMS) && !defined(_WIN32)
    if (flag_print_mem)
      {
+ #ifdef __alpha
+       char *sbrk ();
+ #endif
        char *lim = (char *) sbrk (0);
  
        fprintf (stderr, "Data size %d.\n",
diff -rNci gcc-2.7.2/tree.c gcc-2.7.2p/tree.c
*** gcc-2.7.2/tree.c	Mon Oct  2 01:26:56 1995
--- gcc-2.7.2p/tree.c	Thu Jun 15 12:10:23 1995
***************
*** 2058,2070 ****
      case BIT_FIELD_REF:
        return staticp (TREE_OPERAND (arg, 0));
  
- #if 0
-        /* This case is technically correct, but results in setting
- 	  TREE_CONSTANT on ADDR_EXPRs that cannot be evaluated at
- 	  compile time.  */
      case INDIRECT_REF:
        return TREE_CONSTANT (TREE_OPERAND (arg, 0));
- #endif
  
      case ARRAY_REF:
        if (TREE_CODE (TYPE_SIZE (TREE_TYPE (arg))) == INTEGER_CST
--- 2058,2065 ----
***************
*** 2115,2121 ****
       literal node. */
  
    if (TREE_CONSTANT (t) || (TREE_READONLY (t) && ! TREE_SIDE_EFFECTS (t))
!       || TREE_CODE (t) == SAVE_EXPR || TREE_CODE (t) == ERROR_MARK)
      return t;
  
    /* If T contains a PLACEHOLDER_EXPR, we must evaluate it each time, since
--- 2110,2116 ----
       literal node. */
  
    if (TREE_CONSTANT (t) || (TREE_READONLY (t) && ! TREE_SIDE_EFFECTS (t))
!       || TREE_CODE (t) == SAVE_EXPR)
      return t;
  
    /* If T contains a PLACEHOLDER_EXPR, we must evaluate it each time, since
***************
*** 3598,3604 ****
       handled above.  If this is a language-specific tree code, we can't
       trust what might be in the operand, so say we don't know
       the situation.  */
!   if ((int) code1
        >= sizeof standard_tree_code_type / sizeof standard_tree_code_type[0])
      return -1;
  
--- 3593,3599 ----
       handled above.  If this is a language-specific tree code, we can't
       trust what might be in the operand, so say we don't know
       the situation.  */
!   if (code1
        >= sizeof standard_tree_code_type / sizeof standard_tree_code_type[0])
      return -1;
  
diff -rNci gcc-2.7.2/tree.h gcc-2.7.2p/tree.h
*** gcc-2.7.2/tree.h	Mon Sep 25 21:49:40 1995
--- gcc-2.7.2p/tree.h	Thu Jun 15 12:10:49 1995
***************
*** 1289,1295 ****
  extern tree size_int			PROTO((unsigned HOST_WIDE_INT));
  extern tree round_up			PROTO((tree, int));
  extern tree get_pending_sizes		PROTO((void));
- extern void put_pending_sizes		PROTO((tree));
  
  /* Type for sizes of data-type.  */
  
--- 1289,1294 ----
***************
*** 1298,1304 ****
  /* If nonzero, an upper limit on alignment of structure fields, in bits. */
  extern int maximum_field_alignment;
  
! /* If non-zero, the alignment of a bitstring or (power-)set value, in bits. */
  extern int set_alignment;
  
  /* Concatenate two lists (chains of TREE_LIST nodes) X and Y
--- 1297,1303 ----
  /* If nonzero, an upper limit on alignment of structure fields, in bits. */
  extern int maximum_field_alignment;
  
! /* If non-zero, the alignment of a bitsting or (power-)set value, in bits. */
  extern int set_alignment;
  
  /* Concatenate two lists (chains of TREE_LIST nodes) X and Y
